

-- Gestion du WALLET



gWallet={};
gWallet.wallet=gPlayer:GetWallet();
gWallet.data = Kiki.Commons.Settings(gPluginName.."_wallet", {} );
if gWallet.data[gPlayerName] == nil then
	gWallet.data[gPlayerName] = {};
end
if gWallet.data[gPlayerName][gLanguage] == nil then
	gWallet.data[gPlayerName][gLanguage] = {};
end

-- reset le wallet du joueur actuel
gWallet.Refresh = function()
	if gWallet.wallet ~=nil then
		local tmpIndex;
		for tmpIndex=1,gWallet.wallet:GetSize() do
			local tmpCurr=gWallet.wallet:GetItem(tmpIndex);
			gWallet.data[gPlayerName][gLanguage][tmpCurr:GetName()]={ name=tmpCurr:GetName() ; qty=tmpCurr:GetQuantity() ; backId=nil; iconId = tmpCurr:GetImage(); acc=tmpCurr:IsAccountItem();  };
		end
	end
end
gWallet.Dump = function()
	for k,v in pairs(gWallet.data[gPlayerName][gLanguage]) do
		Kiki.Commons.Trace(k .. "=" .. v.qty);
	end
end

-- filtrage
-- return une table de { desc: description; owner: nom-du-perso; type: vault|bag|wallet|shared; qty: #; iconId: #; backId: # }
gWallet.Filter=function(res, perso,text)
	for usr,wal in pairs(gWallet.data) do
		if perso == nil or perso==usr then 
			for name,d in pairs(wal[gLanguage]) do
				-- update according to Tappo's proposal to fix bug if d.name is nil 
				if (d.name ~= nil) and (#d.name>0) and (text == nil or string.find(d.name, text ,1,true))  then
					-- Match.....
					-- Si l'item du wallet est SHARED, on ne retourne que celui qui est associ au personnage actuel !
					-- si la recherche porte sur l'ensemble des personnages
					-- sinon, on retourne l'item avec le personnage qui match
					if (d.acc == true) then
						-- Item de wallet partag.... on ne prend que ceux de l'utilisateur actuel si on scanne tout, ou on ne prend que si on cible un usr !
						if (perso==nil and name==gPlayerName) or (perso==usr) then
							local v = { desc= d.name; perso=gLang.SHAREDWALLET; loc=gLang.SHAREDWALLET; owner=gLang.SHAREDWALLET; type="wallet"; qty=d.qty; iconId = d.iconId; backId=d.backId   }
							table.insert(res,v);
						end
					else
						-- Item spcialis qui match...
						local v = { desc= d.name; perso=usr; loc=gLang.WALLET; owner=usr.."\n("..gLang.WALLET..")"; type="bag"; qty=d.qty; iconId = d.iconId; backId=d.backId   }
						table.insert(res,v);
					end
				end 
			end
		end
	end
	return res;
end

-- Suppression d'un personnage dans la wallet
gWallet.Delete=function(name)
	gWallet.data[name]=nil;
end

gWallet.Unload = function()
	gWallet.Refresh();
	gWallet.data:Save(gPluginName.."_wallet");
end

-- Chargement
gWallet.Load = function()
	gWallet.Refresh();
end
