
_LANG =
	{
		ALLCHARACTERS= { 
			ENGLISH="All characters"; 
			FRENCH="Tous les personnages"; 
			GERMAN="Alle Charactere";  };
		BAG= { 
			ENGLISH="Bag"; 
			FRENCH="Sac"; 
			GERMAN="Tasche";  };
		BOURSE= { 
			ENGLISH="Wallet: "; 
			FRENCH="Bourse: "; 
			GERMAN="Geldbeutel";  };
		CCSEARCHTOP= { 
			ENGLISH="=================\nSearch:"; 
			FRENCH="=================\nRechercher:"; 
			GERMAN="=================\nSuche:";  };
		CCSEARCHTOP2= { 
			ENGLISH="(case sensitive)"; 
			FRENCH="(sensible Majuscule/Minuscule)"; 
			GERMAN="(Gro- und Kleinschreibung beachten)";  };
		CCSEARCHBOT2= { 
			ENGLISH="================="; 
			FRENCH="================="; 
			GERMAN="=================";  };
		COMMAND	= { 
			ENGLISH="inv"; 
			FRENCH="inv"; 
			GERMAN="inv";  };
		DELETED	= { 
			ENGLISH="Supprim: "; 
			FRENCH="Deleted: "; 
			GERMAN="Gelscht";  };
		QTY= { 
			ENGLISH="Qty"; 
			FRENCH="Qt"; 
			GERMAN="Menge";  };
		MENUDELETE= { 
			ENGLISH="Remove "; 
			FRENCH="Supprimer "; 
			GERMAN="Entfernen";  };
		MENUDELETENA= { 
			ENGLISH="Remove ... "; 
			FRENCH="Supprimer ... "; 
			GERMAN="Entferne ...";  };
		NOTFOUND= { 
			ENGLISH="Not found"; 
			FRENCH="Introuvable"; 
			GERMAN="Nicht gefunden";  };
		SEARCH = { 
			ENGLISH="Search:"; 
			FRENCH="Rechercher:"; 
			GERMAN="Suche";  };
		SELBAG= { 
			ENGLISH="Bags"; 
			FRENCH="Sacs"; 
			GERMAN="Taschen";  };
		SELCHAR= { 
			ENGLISH="Character:"; 
			FRENCH="Personnage:"; 
			GERMAN="Character:";  };
		SELVAULT= { 
			ENGLISH="Vault"; 
			FRENCH="Coffre"; 
			GERMAN="Bank";  };
		SELSHARED= { 
			ENGLISH="Shared storage"; 
			FRENCH="Stockage partag"; 
			GERMAN="Geteilter Lagerraum";  };
		SELWALLET= { 
			ENGLISH="Wallet"; 
			FRENCH="Bourse"; 
			GERMAN="Geldbeutel";  };
		SELALL= { 
			ENGLISH="All"; 
			FRENCH="Tout"; 
			GERMAN="Alle";  };
		SHARED= { 
			ENGLISH="Shared storage"; 
			FRENCH="Stock partag"; 
			GERMAN="Geteilter Lagerraum";  };
		SHAREDWALLET= { 
			ENGLISH="Shared wallet"; 
			FRENCH="Bourse partage"; 
			GERMAN="Geteilter Geldbeutel";  };
		TOTAL= { 
			ENGLISH="Total: "; 
			FRENCH="Total: "; 
			GERMAN="Gesammt:";  };
		TTFILTER= { 
			ENGLISH="Enter text to filter items\n(case sensitive)"; 
			FRENCH="Indiquez un texte pour filtrer les objets\n (sensible Majuscule/Minuscule)"; 
			GERMAN="Gib Text ein zum Filtern von Items\n(Gro- und Kleinschreibung beachten)";  };
		USAGE	= { 
			ENGLISH="usage: /inv -- show Account's inventory window"; 
			FRENCH="usage: /inv -- affiche la fentre de l'inventaire de compte"; 
			GERMAN="Eingabe: /inv -- zeigt das Inventar des Accounts";  };
		USAGE2	= { 
			ENGLISH="usage: /inv text -- Search the text. Displays the result on the chat window"; 
			FRENCH="usage: /inv texte-- Recherche le texte.  Affiche le rsultat sur la fentre de discussion"; 
			GERMAN="Eingabe: /inv text -- Suchen Sie den Text. Zeigt das Ergebnis auf dem Chat-Fenster";  };
		VAULT= { 
			ENGLISH="Vault"; 
			FRENCH="Coffre"; 
			GERMAN="Bank";  };
		WINTITLE= { 
			ENGLISH="Global Inventory"; 
			FRENCH="Inventaire de compte"; 
			GERMAN="Globales Inventar";  };
		WALLET= { 
			ENGLISH="Wallet"; 
			FRENCH="Bourse"; 
			GERMAN="Geldbeutel";  };
	};



function getLang(l)
	local ret = {};
	for k,v in pairs(_LANG) do
		ret[k] = ToUTF8(v[l]);
		if ret[k]=="*" then
			ret[k] = ToUTF8(v["ENGLISH"]);
		end
		if ret[k]=="*" then
			ret[k] = ToUTF8(v["FRENCH"]);
		end
	end
	return ret;
end



